## ESRI UK provide these materials "as is" and without warranty
## or condition of any kind, either express or implied. These
## materials are for demonstration purposes only and are not
## supported. Any code should be thoroughly tested prior to use
import arcpy, sys, string,os, traceback
# add feature class as a layer in a map document
# requires arcgis10 sp1 for layer to persist
try:
#   get path to Temp as we'll use this for layer files etc. later
#
    temp = os.environ.get("temp")

    arcpy.SetProgressor("Step","Add Data to Map",0,100,10)
    arcpy.SetProgressorLabel("Creating Feature Layer")
    #   get class to add to map
    fc = arcpy.GetParameterAsText(0)
    layername = os.path.basename(fc).split(".")[0]
    arcpy.env.workspace = str(os.path.split(fc))
    #   store the name for creating layer in map
    defn = arcpy.GetParameterAsText(1)
    layer= temp + "\\" + layername + ".lyr"

    if arcpy.Exists(layer):
        os.remove(layer)
        
    if defn <> "":
        arcpy.MakeFeatureLayer_management(fc,"lyr",defn)
    else:
        arcpy.MakeFeatureLayer_management(fc,"lyr")
        
    arcpy.SaveToLayerFile_management("lyr",layer)
    arcpy.SetProgressorPosition()

    arcpy.SetProgressorLabel("Adding layer to map")

    mxd = arcpy.mapping.MapDocument("CURRENT")

    df = arcpy.mapping.ListDataFrames(mxd)[0]
#   Create layer obhect in db
    addlayer = arcpy.mapping.Layer(layer)
    addlayer.name=(layername)

    arcpy.mapping.AddLayer(df,addlayer, "AUTO_ARRANGE")

    arcpy.SetProgressorPosition()

    os.remove(layer)

except:
    arcpy.AddMessage(arcpy.GetMessages(2))
    arcpy.AddError("error has occurred in script " + sys.argv[0])
    arcpy.AddMessage( "Terminating Process")
    arcpy.AddMessage( str(sys.exc_info()[0]))
    arcpy.AddMessage( str(sys.exc_info()[1]))
    arcpy.AddMessage( str(traceback.extract_tb(sys.exc_info()[2])))
